Index: /trunk/src/org/expeditee/io/HTMLWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/HTMLWriter.java	(revision 375)
+++ /trunk/src/org/expeditee/io/HTMLWriter.java	(revision 376)
@@ -1,120 +1,95 @@
 package org.expeditee.io;
 
+import java.awt.Image;
+import java.awt.image.BufferedImage;
 import java.io.IOException;
-import java.io.Writer;
 import java.util.List;
 
-import org.expeditee.gui.Frame;
+import org.expeditee.actions.Misc;
+import org.expeditee.gui.FrameIO;
+import org.expeditee.items.FramePicture;
 import org.expeditee.items.Item;
 import org.expeditee.items.Picture;
 import org.expeditee.items.Text;
 
-public class HTMLWriter extends DefaultTreeWriter {
+import sun.awt.image.ToolkitImage;
 
-	private int _indent = 0;
-
-	private static final String INDENT = "   ";
+public class HTMLWriter extends AbstractHTMLWriter {
 
 	@Override
-	protected void initialise(Frame start, Writer writer) throws IOException {
-		_format = ".html";
-		super.initialise(start, writer);
-	}
-
-	@Override
-	protected void writeStartLink(Item linker) throws IOException {
-		// only output text items
-		if (!(linker instanceof Text)) {
-			_indent++;
-			return;
-		}
-
-		Text text = (Text) linker;
-		List<String> toWrite = text.getTextList();
-
-		String first = toWrite.get(0);
-		int ind = first.indexOf(":");
-
-		if (ind > 0) {
-			String tag = first.substring(0, ind);
-			String remain = first.substring(ind + 1);
-
-			if (remain.length() > 0) {
-				// indenting for comments
-				indent();
-				_writer.write("<!-- " + remain);
-
-				for (int i = 1; i < toWrite.size(); i++)
-					_writer.write(ItemWriter.NEW_LINE + toWrite.get(i));
-
-				_writer.write(" -->" + ItemWriter.NEW_LINE);
-			}
-
-			// indenting for tag
-			indent();
-			_writer.write("<" + tag + ">" + ItemWriter.NEW_LINE);
-		}
-
-		_indent++;
-	}
-
-	@Override
-	protected void writeEndLink(Item linker) throws IOException {
-		_indent--;
-
-		// only output text items
-		if (!(linker instanceof Text))
+	protected void writeTitle(Text toWrite, List<Item> items)
+			throws IOException {
+		int indent = getIndent();
+		if (indent == 0)
 			return;
 
-		Text text = (Text) linker;
-		List<String> toWrite = text.getTextList();
-
-		String first = toWrite.get(0);
-		int ind = first.indexOf(":");
-
-		if (ind > 0) {
-			String tag = first.substring(0, ind);
-
-			// indenting for tag
-			indent();
-			_writer.write("</" + tag + ">" + ItemWriter.NEW_LINE);
-		}
-
+		String heading = toWrite.getText();
+		String tag = "h" + indent;
+		// indenting for tag
+		indent();
+		_writer.write("<" + tag + ">" + heading + "</" + tag + ">"
+				+ ItemWriter.NEW_LINE);
 	}
 
 	@Override
 	protected void writeText(Text text) throws IOException {
-		for (String s : text.getTextList()) {
-
-			indent();
-			// check if the first word is proceeded by a :
-			int firstColonIndex = s.indexOf(":");
-			int firstSpaceIndex = s.indexOf(" ");
-			if (firstColonIndex > 0 && firstColonIndex < firstSpaceIndex) {
-				_writer.write("<" + s.substring(0, firstColonIndex) + ">");
-				if (firstColonIndex < s.length())
-					_writer.write(s.substring(firstColonIndex + 1));
-				_writer.write("</" + s.substring(0, firstColonIndex) + ">");
-			} else
-				_writer.write(s);
-			_writer.write(ItemWriter.NEW_LINE);
-		}
-	}
-
-	private void indent() throws IOException {
-		for (int i = 0; i < _indent; i++)
-			_writer.write(INDENT);
+		indent();
+		_writer.write("<p>");
+		_writer.write(text.getText().replace('\n', ' '));
+		_writer.write("</p>" + ItemWriter.NEW_LINE);
 	}
 
 	@Override
 	protected void writePicture(Picture pic) throws IOException {
-		Text source = pic.getSource();
+		// TODO handle different colored @f's of the same frame
+		// TODO handle cropped images
+		Image image = null;
 
-		String line = source.getFirstLine();
-		line = line.substring(line.indexOf(":") + 1).trim();
+		if (pic instanceof FramePicture || pic.isCropped()) {
+			image = pic.getImage();
+			// Crop the image
+			BufferedImage bufferedImage = new BufferedImage(pic
+					.getUnscaledWidth(), pic.getUnscaledHeight(),
+					BufferedImage.TYPE_INT_ARGB);
+			bufferedImage.getGraphics().drawImage(image, 0, 0,
+					pic.getUnscaledWidth(), pic.getUnscaledHeight(),
+					pic.getStart().x, pic.getStart().y, pic.getEnd().x,
+					pic.getEnd().y, null);
+			image = bufferedImage;
+		} else {
+			image = pic.getImage();
+		}
 
+		String filesFolder = getFilesFolder();
+		String fileName;
+		// If its a bufferedImage then just write it out to the files directory
+		// This means it is probably a FrameImage
+		if (image instanceof BufferedImage) {
+			String link = pic.getAbsoluteLink();
+			// Account for the possiblitly of an unlinked buffered image
+			fileName = link == null ? ("Image" + pic.getID()) : link;
+			fileName = Misc.SaveImage((BufferedImage) image, "PNG",
+					FrameIO.EXPORTS_DIR + filesFolder, fileName);
+		} else {// It is a normal Image stored somewhere
+			fileName = pic.getName();
+
+			String oldImageName = FrameIO.IMAGES_PATH + fileName;
+			String newImageName = FrameIO.EXPORTS_DIR + filesFolder + fileName;
+			try {
+				FrameIO.copyFile(oldImageName, newImageName);
+			} catch (Exception e) {
+				filesFolder = "";
+			}
+			if (filesFolder.equals("")) {
+				filesFolder = "../" + FrameIO.IMAGES_FOLDER;
+			}
+		}
 		indent();
-
-		_writer.write("<img src = '../images/" + line + "'>");
+		StringBuffer imageTag = new StringBuffer("<img src=\"");
+		imageTag.append(filesFolder).append(fileName);
+		imageTag.append("\" height=").append(pic.getHeight());
+		imageTag.append(" width=").append(pic.getWidth());
+		imageTag.append(" border=1>");
+		_writer.write(imageTag.toString());
 		_writer.write(ItemWriter.NEW_LINE);
 	}
Index: /trunk/src/org/expeditee/io/TXTWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/TXTWriter.java	(revision 375)
+++ /trunk/src/org/expeditee/io/TXTWriter.java	(revision 376)
@@ -10,5 +10,5 @@
 import org.expeditee.items.Text;
 
-public class TXTWriter extends DefaultTreeWriter{
+public class TXTWriter extends DefaultTreeWriter {
 
 	private boolean _join = false;
@@ -72,12 +72,11 @@
 	@Override
 	protected void writeText(Text text) throws IOException {
-		for (String s : text.getTextList()) {
+		String s = text.getText();
 
-			for (int i = 0; i < _indent; i++)
-				_writer.write("\t");
+		for (int i = 0; i < _indent; i++)
+			_writer.write("\t");
 
-			_writer.write(s);
-			_writer.write(ItemWriter.NEW_LINE);
-		}
+		_writer.write(s);
+		_writer.write(ItemWriter.NEW_LINE);
 
 		if (!_join)
Index: /trunk/src/org/expeditee/io/oldHTMLWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/oldHTMLWriter.java	(revision 376)
+++ /trunk/src/org/expeditee/io/oldHTMLWriter.java	(revision 376)
@@ -0,0 +1,121 @@
+package org.expeditee.io;
+
+import java.io.IOException;
+import java.io.Writer;
+import java.util.List;
+
+import org.expeditee.gui.Frame;
+import org.expeditee.items.Item;
+import org.expeditee.items.Picture;
+import org.expeditee.items.Text;
+
+public class oldHTMLWriter extends DefaultTreeWriter {
+
+	private int _indent = 0;
+
+	private static final String INDENT = "   ";
+
+	@Override
+	protected void initialise(Frame start, Writer writer) throws IOException {
+		_format = ".html";
+		super.initialise(start, writer);
+	}
+
+	@Override
+	protected void writeStartLink(Item linker) throws IOException {
+		// only output text items
+		if (!(linker instanceof Text)) {
+			_indent++;
+			return;
+		}
+
+		Text text = (Text) linker;
+		List<String> toWrite = text.getTextList();
+
+		String first = toWrite.get(0);
+		int ind = first.indexOf(":");
+
+		if (ind > 0) {
+			String tag = first.substring(0, ind);
+			String remain = first.substring(ind + 1);
+
+			if (remain.length() > 0) {
+				// indenting for comments
+				indent();
+				_writer.write("<!-- " + remain);
+
+				for (int i = 1; i < toWrite.size(); i++)
+					_writer.write(ItemWriter.NEW_LINE + toWrite.get(i));
+
+				_writer.write(" -->" + ItemWriter.NEW_LINE);
+			}
+
+			// indenting for tag
+			indent();
+			_writer.write("<" + tag + ">" + ItemWriter.NEW_LINE);
+		}
+
+		_indent++;
+	}
+
+	@Override
+	protected void writeEndLink(Item linker) throws IOException {
+		_indent--;
+
+		// only output text items
+		if (!(linker instanceof Text))
+			return;
+
+		Text text = (Text) linker;
+		List<String> toWrite = text.getTextList();
+
+		String first = toWrite.get(0);
+		int ind = first.indexOf(":");
+
+		if (ind > 0) {
+			String tag = first.substring(0, ind);
+
+			// indenting for tag
+			indent();
+			_writer.write("</" + tag + ">" + ItemWriter.NEW_LINE);
+		}
+
+	}
+
+	@Override
+	protected void writeText(Text text) throws IOException {
+		for (String s : text.getTextList()) {
+
+			indent();
+			// check if the first word is proceeded by a :
+			int firstColonIndex = s.indexOf(":");
+			int firstSpaceIndex = s.indexOf(" ");
+			if (firstColonIndex > 0 && firstColonIndex < firstSpaceIndex) {
+				_writer.write("<" + s.substring(0, firstColonIndex) + ">");
+				if (firstColonIndex < s.length())
+					_writer.write(s.substring(firstColonIndex + 1));
+				_writer.write("</" + s.substring(0, firstColonIndex) + ">");
+			} else
+				_writer.write(s);
+			_writer.write(ItemWriter.NEW_LINE);
+		}
+	}
+
+	private void indent() throws IOException {
+		for (int i = 0; i < _indent; i++)
+			_writer.write(INDENT);
+	}
+
+	@Override
+	protected void writePicture(Picture pic) throws IOException {
+		Text source = pic.getSource();
+
+		String line = source.getFirstLine();
+		line = line.substring(line.indexOf(":") + 1).trim();
+
+		indent();
+
+		_writer.write("<img src = '../images/" + line + "'>");
+		_writer.write(ItemWriter.NEW_LINE);
+	}
+}
Index: /trunk/src/org/expeditee/items/Circle.java
===================================================================
--- /trunk/src/org/expeditee/items/Circle.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Circle.java	(revision 376)
@@ -143,5 +143,5 @@
 				+ Math.pow(Math.abs(_center.getY() - y), 2));
 
-		return Math.abs(distance - radius) < Item.getGravity() * 2;
+		return Math.abs(distance - radius) < getGravity() * 2;
 	}
 
@@ -337,3 +337,8 @@
 		_line.refreshStroke(thick);
 	}
+	
+	@Override
+	public boolean isConnectedToAnnotation() {
+		return false;
+	}
 }
Index: /trunk/src/org/expeditee/items/Dot.java
===================================================================
--- /trunk/src/org/expeditee/items/Dot.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Dot.java	(revision 376)
@@ -26,5 +26,5 @@
 	// Standard Item variables
 
-	private static final int _MINIMUM_DOT_SIZE = 6;
+	//private static final int _MINIMUM_DOT_SIZE = 6;
 
 	private static final int MINIMUM_DOT_SIZE = 2;
@@ -120,4 +120,8 @@
 			// Draw the highlighting rectangle surrounding the dot
 			// this is drawn even if its part of a rectangle
+			
+			if(isVectorItem())
+				updatePolygon();
+			
 			Rectangle rect = getPolygon().getBounds();
 			if (_mode == HighlightMode.Enclosed ||
@@ -177,5 +181,5 @@
 		int thick = Math.round(getThickness());
 		// Sets a minimum size for the dot
-		thick = Math.max(thick, _MINIMUM_DOT_SIZE);
+		thick = Math.max(thick, getGravity() * 2);
 
 		int x = getX() - thick / 2;
Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 376)
@@ -26,4 +26,5 @@
 import org.expeditee.actions.Misc;
 import org.expeditee.actions.Simple;
+import org.expeditee.gui.AttributeValuePair;
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
@@ -31,4 +32,5 @@
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameKeyboardActions;
+import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.FreeItems;
@@ -229,5 +231,8 @@
 	}
 
-	public static int getGravity() {
+	public int getGravity() {
+		if (isVectorItem()) {
+			return 2;
+		}
 		return org.expeditee.gui.UserSettings.Gravity;
 	}
@@ -323,4 +328,6 @@
 
 	protected int _highlightThickness = 2;
+
+	protected int _vectorHighlightThickness = 1;
 
 	// arrowhead parameters
@@ -700,6 +707,6 @@
 	public Color getHighlightColor() {
 		if (_highlightColor.equals(getPaintColor()))
-			return ALTERNATE_HIGHLIGHT;
-		return _highlightColor;
+			return getAlternateHighlightColor();
+		return getDefaultHighlightColor();
 	}
 
@@ -762,4 +769,8 @@
 	public boolean hasFormula() {
 		return _formula != null;
+	}
+	
+	public boolean hasAttributeValuePair() {
+		return _attributeValuePair != null && _attributeValuePair.hasPair();
 	}
 
@@ -853,11 +864,11 @@
 
 	protected Color getPaintHighlightColor() {
-		Color highlightColor = _highlightColor;
+		Color highlightColor = getDefaultHighlightColor();
 		if (hasVisibleBorder()) {
 			if (getPaintBorderColor().equals(highlightColor)) {
-				highlightColor = ALTERNATE_HIGHLIGHT;
+				highlightColor = getDefaultHighlightColor();
 			}
 		} else if (getPaintBackgroundColor().equals(highlightColor)) {
-			highlightColor = ALTERNATE_HIGHLIGHT;
+			highlightColor = getDefaultHighlightColor();
 		}
 		if (getParent() != null
@@ -867,5 +878,5 @@
 		if (hasVisibleBorder()) {
 			if (highlightColor.equals(getBorderColor())
-					&& getThickness() == _highlightThickness) {
+					&& getThickness() == getHighlightThickness()) {
 				highlightColor = new Color(highlightColor.getRed(),
 						highlightColor.getGreen(), highlightColor.getBlue(),
@@ -875,4 +886,30 @@
 
 		return highlightColor;
+	}
+
+	static final int BRIGHTNESS = 185;
+
+	protected Color getDefaultHighlightColor() {
+		if (isVectorItem()
+				&& !this.contains(FrameMouseActions.getX(), FrameMouseActions
+						.getY())) {
+			return new Color(255, BRIGHTNESS, BRIGHTNESS);
+		}
+		return _highlightColor;
+	}
+
+	protected Color getAlternateHighlightColor() {
+		if (isVectorItem()
+				&& !this.contains(FrameMouseActions.getX(), FrameMouseActions
+						.getY())) {
+			return new Color(BRIGHTNESS, BRIGHTNESS, 255);
+		}
+		return ALTERNATE_HIGHLIGHT;
+	}
+
+	protected int getHighlightThickness() {
+		if (isVectorItem())
+			return _vectorHighlightThickness;
+		return _highlightThickness;
 	}
 
@@ -2461,4 +2498,6 @@
 	private Overlay _overlay = null;
 
+	protected AttributeValuePair _attributeValuePair = null;
+
 	/**
 	 * For now there can only be one enclosure per item
@@ -2745,3 +2784,28 @@
 		updatePolygon();
 	}
+
+	protected boolean isVectorItem() {
+		return _editTarget != this;
+	}
+
+	public AttributeValuePair getAttributeValuePair() {
+		if(_attributeValuePair  == null){
+			_attributeValuePair = new AttributeValuePair(getText());
+		}
+		return _attributeValuePair;
+	}
+
+	/*private static Set<Object> _locks = new HashSet<Object>();
+
+	public static void lock(Object itemToLock) {
+		_locks.add(itemToLock);
+	}
+	
+	public static void unlock(Object itemToUnlock) {
+		_locks.remove(itemToUnlock);
+	}
+	
+	public static boolean isLocked(Object item) {
+		return _locks.contains(item);
+	}*/
 }
Index: /trunk/src/org/expeditee/items/Permission.java
===================================================================
--- /trunk/src/org/expeditee/items/Permission.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Permission.java	(revision 376)
@@ -1,13 +1,13 @@
 package org.expeditee.items;
 
-public enum Permission{
+public enum Permission {
 	none, followLinks, copy, createFrames, full;
 
 	/**
-	 * Converts the given Expeditee justification code into a int corresponding
-	 * to the constants defined in Item.
+	 * Converts the given Expeditee permission code into a int corresponding to
+	 * the constants defined in Item.
 	 * 
 	 * @param permissionCode
-	 *            The Expeditee justification code to convert
+	 *            The Expeditee permission code to convert
 	 * @return The resulting int corresponding to one of the constants defined
 	 *         in Item
@@ -16,21 +16,22 @@
 		return getPermission(permissionCode, Permission.full);
 	}
-	
-	public static Permission getPermission(String permissionCode, Permission defaultPermission) {
+
+	public static Permission getPermission(String permissionCode,
+			Permission defaultPermission) {
 		if (permissionCode == null)
 			return defaultPermission;
-		
+
 		permissionCode = permissionCode.trim().toLowerCase();
 		if (permissionCode.length() == 0)
 			return defaultPermission;
-		
+
 		// if it is a single char just match the first character
-		try{
+		try {
 			return values()[Integer.parseInt(permissionCode)];
 			// Otherwise match the whole string
-		}catch(Exception ex){
-			try{
-			return valueOf(permissionCode);
-			}catch (Exception e) {
+		} catch (Exception ex) {
+			try {
+				return valueOf(permissionCode);
+			} catch (Exception e) {
 			}
 		}
@@ -39,5 +40,4 @@
 		return defaultPermission;
 	}
-
 
 	public int getCode() {
@@ -52,5 +52,5 @@
 		return p1.ordinal() < p2.ordinal() ? p1 : p2;
 	}
-	
+
 	public static Permission max(Permission p1, Permission p2) {
 		return p1.ordinal() > p2.ordinal() ? p1 : p2;
Index: /trunk/src/org/expeditee/items/Picture.java
===================================================================
--- /trunk/src/org/expeditee/items/Picture.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Picture.java	(revision 376)
@@ -64,7 +64,7 @@
 	private Point _cropEnd = null;
 
-	private Point _start = new Point(0, 0);;
-
-	private Point _end = new Point(0, 0);;
+	private Point _start = new Point(0, 0);
+
+	private Point _end = new Point(0, 0);
 
 	private boolean _showCropping = false;
@@ -277,4 +277,12 @@
 	}
 
+	public Point getStart() {
+		return _start;
+	}
+	
+	public Point getEnd() {
+		return _end;
+	}
+	
 	/**
 	 * Gets the width with which the picture is displayed on the screen.
@@ -354,5 +362,5 @@
 			g.drawPolygon(getPolygon());
 		}
-		
+
 		if (isHighlighted()) {
 			Stroke borderStroke = new BasicStroke(1, CAP, JOIN);
@@ -361,6 +369,8 @@
 			g.drawPolygon(getPolygon());
 		}
-	}
-	
+		
+		//System.out.print("p_");	
+	}
+
 	@Override
 	public Color getHighlightColor() {
@@ -484,9 +494,29 @@
 
 	public Image getCroppedImage() {
-		if(_image == null)
+		if (_image == null)
 			return null;
-		return Toolkit.getDefaultToolkit().createImage(new FilteredImageSource(
-				_image.getSource(),
-				new CropImageFilter(_start.x, _start.y, getWidth(), getHeight())));
+		if (!isCropped()) {
+			return _image;
+		}
+		
+		return Toolkit.getDefaultToolkit().createImage(
+				new FilteredImageSource(_image.getSource(),
+						new CropImageFilter(_start.x, _start.y,
+								getUnscaledWidth(), getUnscaledHeight())));
+	}
+
+	public int getUnscaledWidth() {
+		return _end.x - _start.x;
+	}
+
+	public int getUnscaledHeight() {
+		return _end.y - _start.y;
+	}
+
+	/**
+	 * @return true if this is a cropped image.
+	 */
+	public boolean isCropped() {
+		return _end.x != 0 || _end.y != 0 || _start.y != 0 || _start.x != 0;
 	}
 
@@ -616,7 +646,7 @@
 
 	}
-	
-	@Override
-	public void scale(Float scale, int originX, int originY){
+
+	@Override
+	public void scale(Float scale, int originX, int originY) {
 		setScale(getScale() * scale);
 		super.scale(scale, originX, originY);
Index: /trunk/src/org/expeditee/items/Text.java
===================================================================
--- /trunk/src/org/expeditee/items/Text.java	(revision 375)
+++ /trunk/src/org/expeditee/items/Text.java	(revision 376)
@@ -259,5 +259,6 @@
 
 	/**
-	 * Sets the text displayed on the screen to the given String
+	 * Sets the text displayed on the screen to the given String. It does not
+	 * reset the formula, attributeValuePair or other cached values.
 	 * 
 	 * @param text
@@ -266,7 +267,15 @@
 	@Override
 	public void setText(String text) {
-		if (_text != null && text.length() < _text.length())
-			invalidateAll();
+		// if (_text != null && text.length() < _text.length())
+		invalidateAll();
 		_text = new StringBuffer(text);
+
+		/*
+		 * Adding the lines below remove formulas when moving in and out of XRay
+		 * mode
+		 */
+		// Reset properties
+		// setProcessedText(null);
+		// setFormula(null);
 		rebuild(true);
 		invalidateAll();
@@ -277,10 +286,19 @@
 			return;
 
-		setText(text.get(0));
-		for (int i = 1; i < text.size(); i++) {
-			appendText("\n");
-			appendText(text.get(i));
-		}
-		rebuild(false);
+		invalidateAll();
+
+		StringBuffer sb = new StringBuffer();
+
+		for (int i = 0; i < text.size(); i++) {
+			sb.append(text.get(i)).append('\n');
+		}
+
+		if (sb.length() > 0)
+			sb.deleteCharAt(sb.length() - 1);
+
+		setText(sb.toString());
+
+		rebuild(true);
+		invalidateAll();
 	}
 
@@ -589,6 +607,5 @@
 			// otherwise, we are inserting text
 		} else {
-			setProcessedText(null);
-			setFormula(null);
+			clearCache();
 			// determine what line is being pointed to
 			line = getLinePosition(mouseY);
@@ -729,4 +746,13 @@
 
 	/**
+	 * 
+	 */
+	private void clearCache() {
+		_attributeValuePair = null;
+		setProcessedText(null);
+		setFormula(null);
+	}
+
+	/**
 	 * @param pos
 	 * @return
@@ -741,9 +767,11 @@
 
 	public Point2D.Float moveCursor(int direction, float mouseX, float mouseY,
-			boolean setSelection) {
+			boolean setSelection, boolean wholeWord) {
 		if (setSelection) {
-			if (getSelectionSize() <= 0) {
+			if (!hasSelection()) {
 				setSelectionStart(mouseX, mouseY);
 			}
+		} else {
+			// clearSelection();
 		}
 
@@ -789,11 +817,26 @@
 				if (direction == LEFT) {
 					if (hit.getInsertionIndex() > 0) {
-						hit = _textLayouts.get(line).getNextLeftHit(hit);
-						// This takes care of the case where the user has put a
-						// hard
-						// line break in
-						if (line > 0
-								&& _text.charAt(hit.getInsertionIndex()
-										+ _lineOffsets.get(line)) == '\n') {
+
+						char prevChar = ' ';
+						do {
+							hit = _textLayouts.get(line).getNextLeftHit(hit);
+
+							// Stop if at the start of the line
+							if (hit.getInsertionIndex() == 0)
+								break;
+							// Keep going if the char to the left is a
+							// letterOrDigit
+							prevChar = _text.charAt(hit.getInsertionIndex() - 1
+									+ _lineOffsets.get(line));
+						} while (wholeWord
+								&& Character.isLetterOrDigit(prevChar));
+						// TODO Go to the start of the word instead of before
+						// the word
+						char nextChar = _text.charAt(hit.getInsertionIndex()
+								+ _lineOffsets.get(line));
+						/*
+						 * This takes care of hard line break in
+						 */
+						if (line > 0 && nextChar == '\n') {
 							line--;
 							hit = _textLayouts.get(line)
@@ -807,4 +850,8 @@
 						hit = _textLayouts.get(line).getNextRightHit(
 								_textLayouts.get(line).getCharacterCount() - 1);
+						/*
+						 * Skip the spaces at the end of a line with soft
+						 * linebreak
+						 */
 						while (hit.getCharIndex() > 0
 								&& _text.charAt(_lineOffsets.get(line)
@@ -817,9 +864,12 @@
 							.getCharacterCount()) {
 						hit = _textLayouts.get(line).getNextRightHit(hit);
-						while (hit.getCharIndex() > 0
+						// Skip whole word if needs be
+						while (wholeWord
+								&& hit.getCharIndex() > 0
 								&& hit.getCharIndex() < _textLayouts.get(line)
 										.getCharacterCount()
-								&& _text.charAt(_lineOffsets.get(line)
-										+ hit.getCharIndex() - 1) == '\t')
+								&& Character.isLetterOrDigit(_text
+										.charAt(_lineOffsets.get(line)
+												+ hit.getCharIndex() - 1)))
 							hit = _textLayouts.get(line).getNextRightHit(hit);
 					} else if (line < _textLayouts.size() - 1) {
@@ -1514,5 +1564,5 @@
 			g.setColor(getPaintHighlightColor());
 			Stroke highlightStroke = new BasicStroke(
-					(float) _highlightThickness, CAP, JOIN);
+					(float) getHighlightThickness(), CAP, JOIN);
 			g.setStroke(highlightStroke);
 			if (HighlightMode.Enclosed.equals(getHighlightMode()))
@@ -1553,5 +1603,5 @@
 				}
 
-				layout.draw(g, getX() + getJustOffset(layout), y);
+				layout.draw(g, 1 + getX() + getJustOffset(layout), y);
 
 				/*
@@ -1608,5 +1658,9 @@
 		copy.setWidth(getWidth());
 		copy.setFont(getFont());
-		copy.setText(_text.toString());
+		if (hasFormula()) {
+			copy.calculate(getFormula());
+		} else {
+			copy.setText(_text.toString());
+		}
 		copy.setHidden(!isVisible());
 		// copy.setWidth(getWidth());
@@ -1798,7 +1852,8 @@
 		Frame modelFrame = getParentOrCurrentFrame();
 		if (modelFrame != null) { 
-			setRightMargin(getParentOrCurrentFrame().getNameItem().getX()
+			setRightMargin(modelFrame.getNameItem().getX()
 					- MARGIN_LEFT);
 		} else {
+			System.out.print("Error: text.resetTitlePosition, getParent or currentFrame returned null");
 			setRightMargin(MARGIN_LEFT);
 		}
@@ -1837,8 +1892,9 @@
 		Text template = this.copy();
 		template.setID(-1);
-		// The template must have text otherwise the bounds height will be
-		// zero!!
-		// This will stop escape drop down from working if there is no item
-		// template
+		/*
+		 * The template must have text otherwise the bounds height will be
+		 * zero!! This will stop escape drop down from working if there is no
+		 * item template
+		 */
 		template.setText("@");
 		return template;
@@ -1958,4 +2014,6 @@
 			return false;
 		}
+		formula = formula.replace(':', '=');
+
 		String lowercaseFormula = formula.toLowerCase();
 		ExpediteeJEP myParser = new ExpediteeJEP();
@@ -1970,5 +2028,5 @@
 				continue;
 			if (i instanceof Text && !i.isAnnotation()) {
-				AttributeValuePair pair = new AttributeValuePair(i.getText());
+				AttributeValuePair pair = i.getAttributeValuePair();
 				if (pair.hasPair()) {
 					try {
@@ -1985,5 +2043,6 @@
 				try {
 					double value = pair.getDoubleValue();
-					myParser.addVariable("$" + nextVarNo++, value);
+					if (value != Double.NaN)
+						myParser.addVariable("$" + nextVarNo++, value);
 				} catch (NumberFormatException nfe) {
 					continue;
@@ -2022,9 +2081,19 @@
 				this.setText(result);
 				this.setFormula(formula);
+
+				if (!this.hasAction()) {
+					setActionMark(false);
+					setAction("extract formula");
+				}
 			}
 		} catch (Throwable e) {
-			this.setText(getFormula());
+			String formula2 = getFormula();
+			this.setText(formula2);
+			this.setFormula(formula2);
 			return false;
 		}
+
+		_attributeValuePair = null;
+
 		return true;
 	}
@@ -2042,6 +2111,8 @@
 		double enclosureArea = Double.MAX_VALUE;
 		for (Item i : parent.getVisibleItems()) {
-			// Go through all the enclosures looking for one that includes this
-			// shape
+			/*
+			 * Go through all the enclosures looking for one that includes this
+			 * item
+			 */
 			if (!seen.contains(i) && i.isEnclosed()) {
 				seen.addAll(i.getEnclosingDots());
@@ -2064,16 +2135,21 @@
 
 	/**
-	 * Returns true if this text item should be recalculated when it is modified
+	 * Returns true if items of the parent frame should be recalculated when
+	 * this item is modified
 	 */
 	public boolean recalculateWhenChanged() {
 		if (/*
 			 * !isAnnotation() &&
-			 */(hasFormula() || getText().contains(":") || isLineEnd()))
+			 */(hasFormula() || isLineEnd()))
 			return true;
 		try {
-			Double.parseDouble(getText());
-			return true;
+			AttributeValuePair avp = getAttributeValuePair();
+
+			if (!avp.getDoubleValue().equals(Double.NaN))
+				return true;
 		} catch (Exception e) {
-		}
+			e.printStackTrace();
+		}
+
 		return false;
 	}
Index: /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java	(revision 375)
+++ /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java	(revision 376)
@@ -59,6 +59,6 @@
 				 * changed so it will be refreshed when the user goes back
 				 */
-				assert(false);
-				//_needsUpdating = true;
+				assert (false);
+				// _needsUpdating = true;
 				// update();
 			}
@@ -119,4 +119,7 @@
 		if (oldLink == null) {
 			_needsUpdating = true;
+			// Need to refresh imediately so that the data appears when adding a
+			// link to a graph
+			refresh();
 		} else {
 			refresh();
Index: /trunk/src/org/expeditee/items/widgets/SampleWidget2.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/SampleWidget2.java	(revision 375)
+++ /trunk/src/org/expeditee/items/widgets/SampleWidget2.java	(revision 376)
@@ -2,7 +2,9 @@
 
 
+import java.awt.Color;
 import java.awt.FlowLayout;
+import java.awt.Font;
 
-import javax.swing.JButton;
+import javax.swing.JCheckBox;
 import javax.swing.JComboBox;
 import javax.swing.JLabel;
@@ -10,4 +12,5 @@
 import javax.swing.JSplitPane;
 import javax.swing.JTextArea;
+import javax.swing.JToggleButton;
 
 import org.expeditee.items.Text;
@@ -21,22 +24,36 @@
 		super(source, new JSplitPane(JSplitPane.VERTICAL_SPLIT), 60, -1, 40, -1);
 
+		Font bigFont = null;
+		
 		JSplitPane sp = (JSplitPane)super._swingComponent;
 		
 		JPanel p = new JPanel(new FlowLayout());
+		p.setBackground(new Color(255,228,195));
 
-		JLabel lbl = new JLabel("This widget has multiple JComponents!");
+		JLabel lbl = new JLabel("This is an example InteractiveWidget!");
+		bigFont = lbl.getFont().deriveFont(24F);
+		lbl.setFont(bigFont);
 		
-		JButton button = new JButton("Click Me!");
+		JToggleButton button = new JToggleButton("Toggle Style");
+		button.setFont(bigFont);
 		
-		JButton button2 = new JButton("Or Me!");
+		JCheckBox checkBox = new JCheckBox("Big Font");
+		checkBox.setBackground(null);
+		checkBox.setSelected(true);
+		checkBox.setFont(bigFont);
+		
+		
+		//JButton button2 = new JButton("Example CheckBox");
 		
 		_text = new JTextArea();
+		_text.setFont(bigFont);
 		
-		_combo = new JComboBox(new String[] {"Item 1", "Item 2", "Item 3", "Item 21", "Item 22", "Item 23", "Item 31", "Item 32", "Item 33", "Item 41", "Item 42", "Item 43"});
+		_combo = new JComboBox(new String[] {"Peach", "Item 2", "Item 3", "Item 21", "Item 22", "Item 23", "Item 31", "Item 32", "Item 33", "Item 41", "Item 42", "Item 43"});
+		_combo.setFont(bigFont);
 		
 		p.add(lbl);
 		p.add(_combo);
 		p.add(button);
-		p.add(button2);
+		p.add(checkBox);
 		
 		sp.setTopComponent(p);
Index: /trunk/src/org/expeditee/items/widgets/charts/AbstractCategory.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/charts/AbstractCategory.java	(revision 375)
+++ /trunk/src/org/expeditee/items/widgets/charts/AbstractCategory.java	(revision 376)
@@ -54,5 +54,5 @@
 					}
 				}
-			} catch (NumberFormatException e) {
+			} catch (Exception e) {
 
 			}
